; TXTPAC.LSP

; =======================================
; texte sur une polyligne / arc / cercle
; =======================================


(defun c:TXTPAC ()

(setvar "cmdecho" 0)


(setq ent_po (entsel "\nSlectionnez une polyligne, cercle ou arc: "))


(setq ent (car ent_po))
(setq pos (cadr ent_po))


(if (or (= (cdr (assoc 0 (entget ent))) "3DFACE")
        (= (cdr (assoc 0 (entget ent))) "ATTRIB")
        (= (cdr (assoc 0 (entget ent))) "INSERT")
        (= (cdr (assoc 0 (entget ent))) "POINT")
        (= (cdr (assoc 0 (entget ent))) "SHAPE")
        (= (cdr (assoc 0 (entget ent))) "SOLID")
        (= (cdr (assoc 0 (entget ent))) "TEXT")
        (= (cdr (assoc 0 (entget ent))) "TRACE")
     )
(setq msg "\nCette entit n'est ni une LIGNE, POLYLIGNE, ARC ou CERCLE.")

(progn

        (block)

        (setq txt (getstring t "\nTEXTE: "))

        (setq lg_txt (strlen txt))

        (setq ht_txt (cdr (assoc 40 (tblsearch "style" (getvar "textstyle")))))

        (setq ex_txt (cdr (assoc 41 (tblsearch "style" (getvar "textstyle")))))
        (setq ex_txt (+ ex_txt (/ ex_txt 10.0)))

        (if (= ht_txt 0.0)
                (setq ht_txt (getdist "\nHauteur du texte: "))
        )

        (command "_measure" pos "b" "$" "o" (* ht_txt ex_txt))


        (setq obj (ssget "x" (list (cons 0 "INSERT") (cons 2 "$"))))

        (setq nb_obj (sslength obj))


        (if (>= nb_obj lg_txt)
        (progn

                (setq msg "")

                (setq lst_obj nil)
                (setq compte 0)

                (repeat nb_obj
                        (setq lst_obj (append lst_obj (list (ssname obj compte))))
                        (setq compte (1+ compte))
                )

                (setq lst_obj (reverse lst_obj))

                (setq delta_x (- (car (cdr (assoc 10 (entget (nth 1 lst_obj)))))
                                 (car (cdr (assoc 10 (entget (nth 0 lst_obj)))))
                              )
                )
                (setq delta_y (- (cadr (cdr (assoc 10 (entget (nth 1 lst_obj)))))
                                 (cadr (cdr (assoc 10 (entget (nth 0 lst_obj)))))
                              )
                )

                

                (if (= (minusp delta_x) T)
                (setq lst_obj (reverse lst_obj))
                )

           

                (setq dec_txt (getdist "\nDcalage du texte: " 
                        (cdr (assoc 10 (entget (nth 0 lst_obj))))
                        )
                )

                (setq compte 0)

                (if (= (minusp delta_x) nil)
                (progn

                (repeat lg_txt

                        (command "texte" 
                                (polar
                                        (cdr (assoc 10 (entget (nth compte lst_obj)))) 
                                        (+ (cdr (assoc 50 (entget (nth compte lst_obj)))) (* 0.5 pi))
                                        dec_txt
                                )
                                ht_txt
                                (angtos (cdr (assoc 50 (entget (nth compte lst_obj)))) 0 2)
                                (substr txt (1+ compte) 1)
                        )

                        (setq compte (1+ compte))

                )
                ); progn
                (progn

                (repeat lg_txt

                        (command "texte" 
                                (polar
                                        (cdr (assoc 10 (entget (nth compte lst_obj)))) 
                                        (+ (cdr (assoc 50 (entget (nth compte lst_obj)))) (* 1.5 pi))
                                        dec_txt
                                )
                                ht_txt
                                (angtos (+ (cdr (assoc 50 (entget (nth compte lst_obj)))) pi) 0 2)
                                (substr txt (1+ compte) 1)
                        )

                        (setq compte (1+ compte))

                )
                );progn
                );if
)
(setq msg "\nTexte trop long pour l'objet...")
)

(command "effacer" obj "")
)
)

(princ msg)


(princ)

)


(defun block ()

(setq bl (tblsearch "BLOCK" "$"))

(if (= bl nil)
(progn
        (command "_line" "0,0" "1,0" "")
        (command "_block" "$" "0,0" "d" "")
)
)
)

(princ "\n==> TXTPAC")
(princ)

